#
# Conditional build:
%bcond_with	initrd		# without initrd version
%bcond_with	dietlibc	# build initrd version with static glibc instead of dietlibc
%bcond_without	selinux		# build without SELinux support (needs selinux-disabled device-mapper)

%define		rel	2
%define		subver	rc16.3
Summary:	Device-mapper RAID tool
Summary(pl.UTF-8):	Narzędzie do RAID-u opartego o device-mapper
Name:		dmraid
Version:	1.0.0
Release:	0.%{subver}.%{rel}
License:	GPL v2+
Group:		Base
Source0:	http://people.redhat.com/~heinzm/sw/dmraid/src/%{name}-%{version}.rc16-3.tar.bz2
# Source0-md5:	819338fcef98e8e25819f0516722beeb
Patch0:		%{name}-selinux-static.patch
Patch1:		%{name}-optflags.patch
Patch2:		%{name}-unsigned.patch
Patch3:		%{name}-diet.patch
Patch4:		%{name}-format.patch
URL:		http://people.redhat.com/~heinzm/sw/dmraid/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	device-mapper-devel >= 1.02.02
BuildRequires:	zlib-devel
%if %{with initrd}
	%if %{with dietlibc}
BuildRequires:	device-mapper-dietlibc
BuildRequires:	dietlibc-static >= 2:0.31-5
	%else
BuildRequires:	device-mapper-static >= 1.02.05-0.4
BuildRequires:	glibc-static
BuildRequires:	udev-static
%if %{with selinux}
BuildRequires:	libselinux-static
BuildRequires:	libsepol-static
%endif
	%endif
%endif
%if %{with selinux}
BuildRequires:	libselinux-devel
BuildRequires:	libsepol-devel
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sbindir	/sbin

%description
DMRAID supports device discovery, set activation and display of
properties for ATARAID on Linux >= 2.4 using device-mapper.

%description -l pl.UTF-8
DMRAID obsługuje wykrywanie urządzeń, ustawianie aktywacji i
wyświetlanie właściwości ATARAID-u na Linuksie >= 2.4 przy użyciu
device-mappera.

%package devel
Summary:	Header files for dmraid library
Summary(pl.UTF-8):	Pliki nagłówkowe biblioteki dmraid
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
dmraid-devel provides a library interface for RAID device discovery,
RAID set activation and display of properties for ATARAID volumes.

%description devel -l pl.UTF-8
Ten pakiet udostępnia interfejs biblioteczny do wykrywania urządzeń
RAID, włączania zestawu RAID i wyświetlania właściwości wolumenów
ATARAID.

%package static
Summary:	Static library for dmraid
Summary(pl.UTF-8):	Statyczna biblioteka dmraid
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
dmraid-static provides a library interface for RAID device discovery,
RAID set activation and display of properties for ATARAID volumes.

%description static -l pl.UTF-8
Ten pakiet udostępnia statyczną bibliotekę do wykrywania urządzeń
RAID, włączania zestawu RAID i wyświetlania właściwości wolumenów
ATARAID.

%package initrd
Summary:	Device-mapper RAID tool - statically linked version
Summary(pl.UTF-8):	Narzędzie do RAID-u opartego o device-mapper - wersja statyczna
Group:		Base
Conflicts:	geninitrd < 10000.10

%description initrd
Statically linked version of dmraid utility.

%description initrd -l pl.UTF-8
Statycznie skonsolidowana wersja programu narzędziowego dmraid.

%prep
%setup -q -n %{name}
mv %{version}.*/dmraid/* .
%{?with_selinux:%patch0 -p2}
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

%build
cp -f /usr/share/automake/config.sub autoconf
%{__aclocal}
%{__autoconf}

%if %{with initrd}
%configure \
	%if %{with dietlibc}
	CC="diet %{__cc} %{rpmcflags} %{rpmldflags} -Os -static" \
	--disable-libselinux \
	--disable-libsepol \
	%else
		%if %{with selinux}
	--enable-libselinux \
	--enable-libsepol \
		%endif
	%endif
	--enable-static_link

%{__make} -j1
mv -f tools/dmraid dmraid-initrd
%{__make} clean
%endif

%configure \
	--with-usrlibdir=%{_libdir} \
	--disable-static_link \
	--enable-led \
	--enable-intel_led
%{__make} -j1

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/%{_lib}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

mv $RPM_BUILD_ROOT%{_libdir}/libdmraid.so.* $RPM_BUILD_ROOT/%{_lib}
ln -sf /%{_lib}/$(cd $RPM_BUILD_ROOT/%{_lib} ; echo libdmraid.so.*.*.*) \
        $RPM_BUILD_ROOT%{_libdir}/libdmraid.so

%if %{with initrd}
install -d $RPM_BUILD_ROOT%{_libdir}/initrd
install -p dmraid-initrd $RPM_BUILD_ROOT%{_libdir}/initrd/dmraid
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc CHANGELOG CREDITS KNOWN_BUGS README TODO doc/dmraid_design.txt
%attr(755,root,root) %{_sbindir}/dmevent_tool
%attr(755,root,root) %{_sbindir}/dmraid
%attr(755,root,root) /%{_lib}/libdmraid.so.*.*.*
%attr(755,root,root) %ghost /%{_lib}/libdmraid.so.1
%attr(755,root,root) %{_libdir}/libdmraid-events-isw.so
%attr(755,root,root) %{_libdir}/device-mapper/libdmraid-events-isw.so
%{_mandir}/man8/dmevent_tool.8*
%{_mandir}/man8/dmraid.8*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libdmraid.so
%{_includedir}/dmraid

%files static
%defattr(644,root,root,755)
%{_libdir}/libdmraid.a

%if %{with initrd}
%files initrd
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/initrd/dmraid
%endif
%changelog
* Tue Mar 03 2015 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/dmraid.git;a=log;h=master

* Tue Mar 03 2015 Elan Ruusamäe <glen@delfi.ee> e21bd24
- rebuild for x32

* Sat Dec 07 2013 Jan Rękorajski <baggins@pld-linux.org> 3dfbba1
- disable initrd packages
- updated configure options

* Wed Oct 16 2013 Jakub Bogusz <qboosh@pld-linux.org> b22dd63
- updated to 1.0.0.rc16-3
- updated optflags,unsigned patches
- removed obsolete fix,as-needed patches
- added format patch (fixes build with -Werror=format-security)

* Sat Apr 28 2012 Jan Rękorajski <baggins@pld-linux.org> 2d5d6d7
- build without dietlibc (devmapper doesn't build properly with it, so deps unfulfilled)
- drag more libs, devmapper really needs libudev

* Sat Apr 28 2012 Jan Rękorajski <baggins@pld-linux.org> bf59828
- rel 6
- drop initramfs package, it was never properly tested, never really updated
  and initramfs-tools functionality is obsoleted by dracut

* Mon Apr 06 2009 Jan Rękorajski <baggins@pld-linux.org> d0a6621
- rel 5
- proper C on geninitrd

* Mon Mar 23 2009 Jan Rękorajski <baggins@pld-linux.org> fcfd532
- unify dietlibc compile options and calls

* Mon Mar 23 2009 Jan Rękorajski <baggins@pld-linux.org> 722de73
- Conflicts: geninitrd <= 10000.3 (geninitrd-10000.3 doesn't know _libdir/initrd)

* Mon Mar 23 2009 Jan Rękorajski <baggins@pld-linux.org> 152b8c5
- put programs for initrd into common directory _libdir/initrd

* Wed Mar 18 2009 Jan Rękorajski <baggins@pld-linux.org> eec64f5
- fix static link (selinux_static patch)
- clean bconds
- fix 64bit diet build

* Wed Mar 18 2009 Jan Rękorajski <baggins@pld-linux.org> 9a7fa99
- proper fix

* Wed Mar 18 2009 Jan Rękorajski <baggins@pld-linux.org> 6a37828
- dietlibc doesn't have lseek64 too

* Wed Mar 18 2009 Jan Rękorajski <baggins@pld-linux.org> bd4431a
- fix bcond

* Wed Mar 18 2009 Jan Rękorajski <baggins@pld-linux.org> 68c065c
- rel 4
- added unsigned patch (uint -> unsigned int, die, BSD, die!)
- build with dietlibc by default
- no selinux in dietlibc-based initrd binary

* Wed Mar 18 2009 Jan Rękorajski <baggins@pld-linux.org> ed2bd0c
- die, BSD, die!

* Fri Feb 27 2009 Jan Rękorajski <baggins@pld-linux.org> 6f013d0
- rel 3
- moved dmraid binary and library to /

* Thu Feb 26 2009 Jan Rękorajski <baggins@pld-linux.org> 88fb31a
- rel 2

* Thu Feb 26 2009 Jan Rękorajski <baggins@pld-linux.org> 24071a5
- added initramfs subpackage (NEED TESTERS)

* Thu Feb 26 2009 Jan Rękorajski <baggins@pld-linux.org> 5f1d208
- added initramfs support files to package

* Thu Feb 26 2009 Jan Rękorajski <baggins@pld-linux.org> 69e8861
- support for initramfs-tools

